package com.redhat.installer.postinstall;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.io.File;
import java.util.Properties;
import java.util.Set;

import org.apache.tools.ant.util.TeeOutputStream;

import com.izforge.izpack.installer.AutomatedInstallData;
import com.izforge.izpack.util.AbstractUIProcessHandler;

public class LogIzPackVars {
	private static PrintStream log = null;
	
	// logs all of the izpack variables to the log file. ran at the end of the installation
	public static void run (AbstractUIProcessHandler handler, String[]args){
		AutomatedInstallData idata = AutomatedInstallData.getInstance();
		// this should be the same ref as the one in ServerCommands. perhaps convert to static ref
		// in a utility class later
		// anything any instance of this class does needs to be appended to the given file
		FileOutputStream logFile = null;
		try {
			// destroys any hope of usability of this class outside the installer.
			logFile = new FileOutputStream(idata.getInstallPath()+"/"+idata.getVariable("installation.logfile"),true);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		
		if (log == null) {
				log = new PrintStream(new TeeOutputStream(System.out, logFile));
		}
		
		// CommandContext uses System.out and System.err calls internally. Thus we must redirect System.out / System.err to the log file.
		// this is an unavoidable, dirty hack due to CommandContext.
		System.setOut(log);
		System.setErr(log);
		
		
		Properties allVars = idata.getVariables();

		Set<Object> keys = allVars.keySet();
		
		for (Object key : keys){
			String realKey = (String) key;
			if (realKey.toLowerCase().contains("password")){
				// don't print password fields
				continue; 
			} else {
				log.println(realKey + " = " + allVars.get(key));
			}
		}
		String dialect = idata.getVariable("db.dialect");
		if (dialect != null){
			System.setProperty("db.dialect", dialect);
		}
		//logFile.close();
        //ProcessPanelHelper.printToPanel(handler, "IzPack variable state written to "+ idata.getInstallPath()+"/"+idata.getVariable("installation.logfile"),false);
        ProcessPanelHelper.printToPanel(handler, idata.langpack.getString("LogIzPackVars.message") + " " + idata.getInstallPath()+File.separator+idata.getVariable("installation.logfile"),false);
	}
}
